Index: vtcross/trunk/src/cognitive_engines/Makefile.am
===================================================================
--- vtcross/trunk/src/cognitive_engines/Makefile.am	(revision 218)
+++ vtcross/trunk/src/cognitive_engines/Makefile.am	(revision 323)
@@ -1,2 +1,4 @@
+include $(top_srcdir)/Makefile.common
+
 INCLUDES = -I$(top_srcdir)/src/include
 
@@ -6,4 +8,4 @@
 
 cbr_demo_SOURCES = CognitiveEngine.cpp cbr_demo.cpp
-cbr_demo_LDADD = -lsqlite3 ../lib/socketcomm/libsocketcomm.a
+cbr_demo_LDADD = -lsqlite3 $(CROSS_SOCKETCOMM_LA) 
 
Index: vtcross/trunk/src/include/vtcross/Makefile.am
===================================================================
--- vtcross/trunk/src/include/vtcross/Makefile.am	(revision 199)
+++ vtcross/trunk/src/include/vtcross/Makefile.am	(revision 323)
@@ -1,2 +1,4 @@
+include $(top_srcdir)/Makefile.common
+
 include_HEADERS = error.h debug.h socketcomm.h cbr.h components.h \
 				  containers.h libvtcross.h common.h config.h
Index: vtcross/trunk/src/include/tinyxml/Makefile.am
===================================================================
--- vtcross/trunk/src/include/tinyxml/Makefile.am	(revision 161)
+++ vtcross/trunk/src/include/tinyxml/Makefile.am	(revision 323)
@@ -1,1 +1,4 @@
+include $(top_srcdir)/Makefile.common
+
+
 include_HEADERS = tinystr.h tinyxml.h
Index: vtcross/trunk/src/include/Makefile.am
===================================================================
--- vtcross/trunk/src/include/Makefile.am	(revision 161)
+++ vtcross/trunk/src/include/Makefile.am	(revision 323)
@@ -1,1 +1,3 @@
+include $(top_srcdir)/Makefile.common
+
 SUBDIRS = vtcross tinyxml
Index: vtcross/trunk/src/lib/socketcomm/Makefile.am
===================================================================
--- vtcross/trunk/src/lib/socketcomm/Makefile.am	(revision 317)
+++ vtcross/trunk/src/lib/socketcomm/Makefile.am	(revision 323)
@@ -1,2 +1,4 @@
+include $(top_srcdir)/Makefile.common
+
 INCLUDES = -I$(top_srcdir)/src/include
 
Index: vtcross/trunk/src/lib/tinyxml/Makefile.am
===================================================================
--- vtcross/trunk/src/lib/tinyxml/Makefile.am	(revision 161)
+++ vtcross/trunk/src/lib/tinyxml/Makefile.am	(revision 323)
@@ -1,2 +1,4 @@
+include $(top_srcdir)/Makefile.common
+
 INCLUDES = -I$(top_srcdir)/src/include/tinyxml
 
Index: vtcross/trunk/src/lib/Makefile.am
===================================================================
--- vtcross/trunk/src/lib/Makefile.am	(revision 161)
+++ vtcross/trunk/src/lib/Makefile.am	(revision 323)
@@ -1,1 +1,3 @@
+include $(top_srcdir)/Makefile.common
+
 SUBDIRS = socketcomm tinyxml
Index: vtcross/trunk/src/policy_engines/Makefile.am
===================================================================
--- vtcross/trunk/src/policy_engines/Makefile.am	(revision 161)
+++ vtcross/trunk/src/policy_engines/Makefile.am	(revision 323)
@@ -1,2 +1,4 @@
+include $(top_srcdir)/Makefile.common
+
 INCLUDES = -I$(top_srcdir)/src/include
 
@@ -6,4 +8,3 @@
 
 policy_demo_SOURCES = PolicyEngine.cpp policy_demo.cpp
-policy_demo_LDADD = ../lib/socketcomm/libsocketcomm.a
-
+policy_demo_LDADD = $(CROSS_SOCKETCOMM_LA) 
Index: vtcross/trunk/src/shell/Makefile.am
===================================================================
--- vtcross/trunk/src/shell/Makefile.am	(revision 207)
+++ vtcross/trunk/src/shell/Makefile.am	(revision 323)
@@ -1,2 +1,4 @@
+include $(top_srcdir)/Makefile.common
+
 INCLUDES = -I$(top_srcdir)/src/include
 
@@ -6,4 +8,3 @@
 
 shell_demo_SOURCES = CognitiveRadioShell.cpp shell_demo.cpp
-shell_demo_LDADD = ../lib/tinyxml/libtinyxml.a ../lib/socketcomm/libsocketcomm.a
-
+shell_demo_LDADD = $(CROSS_XML_A) $(CROSS_SOCKETCOMM_LA) 
Index: vtcross/trunk/src/service_management_layer/Makefile.am
===================================================================
--- vtcross/trunk/src/service_management_layer/Makefile.am	(revision 281)
+++ vtcross/trunk/src/service_management_layer/Makefile.am	(revision 323)
@@ -1,2 +1,4 @@
+include $(top_srcdir)/Makefile.common
+
 INCLUDES = -I$(top_srcdir)/src/include
 
@@ -6,3 +8,3 @@
 
 sml_demo_SOURCES = ServiceManagementLayer.cpp sml_demo.cpp
-sml_demo_LDADD = -ldl -lpthread -lsqlite3  ../lib/tinyxml/libtinyxml.a ../lib/socketcomm/libsocketcomm.a
+sml_demo_LDADD = -ldl -lpthread -lsqlite3  $(CROSS_XML_A) $(CROSS_SOCKETCOMM_LA) 
Index: vtcross/trunk/src/Makefile.am
===================================================================
--- vtcross/trunk/src/Makefile.am	(revision 181)
+++ vtcross/trunk/src/Makefile.am	(revision 323)
@@ -1,2 +1,5 @@
+include $(top_srcdir)/Makefile.common
+
+
 SUBDIRS = lib include policy_engines cognitive_engines service_management_layer \
 		  libvtcross shell
Index: vtcross/trunk/src/libvtcross/Makefile.am
===================================================================
--- vtcross/trunk/src/libvtcross/Makefile.am	(revision 299)
+++ vtcross/trunk/src/libvtcross/Makefile.am	(revision 323)
@@ -1,2 +1,4 @@
+include $(top_srcdir)/Makefile.common
+
 INCLUDES = -I$(top_srcdir)/src/include
 
@@ -6,10 +8,10 @@
 libvtcross_la_SOURCES = libvtcross.cpp
 libvtcross_la_LDFLAGS = -version-info 1:0:0
-libvtcross_la_LIBADD = ../lib/socketcomm/libsocketcomm.a
+libvtcross_la_LIBADD = $(CROSS_SOCKETCOMM_LA) 
 
 libvtcross_demo_SOURCES = libvtcross_demo.cpp
-libvtcross_demo_LDADD = libvtcross.la
+libvtcross_demo_LDADD = $(CROSS_LA) 
 
 libvtcross_demo_sml_SOURCES = libvtcross_demo_sml.cpp
-libvtcross_demo_sml_LDADD = libvtcross.la
+libvtcross_demo_sml_LDADD = $(CROSS_LA)
 
Index: vtcross/trunk/src/libvtcross/swig/Makefile.am
===================================================================
--- vtcross/trunk/src/libvtcross/swig/Makefile.am	(revision 299)
+++ vtcross/trunk/src/libvtcross/swig/Makefile.am	(revision 323)
@@ -1,2 +1,5 @@
+include $(top_srcdir)/Makefile.common
+
+
 BUILT_SOURCES = $(srcdir)/libvtcross_wrap.cpp
 SWIG_SOURCES = libvtcross.i